#ifdef USE_SDL

/*#include <stdio.h>
#include <SDL.h>
#include <SDL_video.h>
#include <SDL_events.h>*/
#include "h2def.h"
#include "soundst.h"

#include "palmos5.h"

#include "pnobridge.h"
#include "PNOMain.h"

extern char gpstr[256];
extern int usemouse;

int mouse_scale_factor;

int SCREENWIDTH,SCREENHEIGHT;

/* RGB palette for RGB rendering with direct color coding */

UInt16 curpal[256]; 
int g_scr_rotated=0;

int VSDL_InitGraphics(void) {
	

 return 1;
}

void VSDL_ShutdownGraphics(void)
{

}


#define KEY_UP				0x00000001
#define KEY_DOWN			0x00000002
#define KEY_LEFT			0x00000004
#define KEY_RIGHT			0x00000008
#define KEY_RUN				0x00000010
#define KEY_STRAFE			0x00000020
#define KEY_STRAFE_L		0x00000040
#define KEY_STRAFE_R		0x00000080
#define KEY_FIRE			0x00000100
#define KEY_USE				0x00000200
#define KEY_CHANGEWEAPON	0x00000400
#define KEY_MAP 			0x00000800
#define KEY_MENU			0x00001000
#define KEY_USEARTIFACT		0x00002000
#define KEY_JUMP			0x00004000
#define KEY_INV_LEFT		0x00008000
#define KEY_LOOKUP			0x00010000
#define KEY_LOOKCENTER		0x00020000
#define KEY_LOOKDOWN		0x00040000
#define KEY_FLYUP			0x00080000
#define KEY_FLYCENTER		0x00100000
#define KEY_FLYDOWN			0x00200000
#define KEY_INV_RIGHT		0x00400000
#define KEY_GAMMA			0x00800000
#define KEY_PLUS			0x01000000
#define KEY_MOINS			0x02000000

unsigned int g_translateBtn[30]=
{KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,
KEY_RUN,KEY_STRAFE,KEY_STRAFE_L,KEY_STRAFE_R,
KEY_FIRE,KEY_USE,KEY_CHANGEWEAPON,KEY_MAP,KEY_MENU,
KEY_USEARTIFACT,KEY_JUMP,KEY_INV_LEFT,KEY_INV_RIGHT,
KEY_LOOKUP,KEY_LOOKDOWN,KEY_LOOKCENTER,
KEY_FLYUP,KEY_FLYDOWN,KEY_FLYCENTER,KEY_GAMMA,KEY_PLUS,KEY_MOINS,0,0,0,0
};

extern int g_confinput[30];

char consoleCmd[256];

void VSDL_GetEvent(void)
{
	static pollcpt=0;
	event_t event;
	
	static UInt32 old_key=0;
	UInt32 key;
	UInt32 keyval;
	static UInt32 penX,penY,penDown;
	int i;
	
	pollcpt++;
	if (pollcpt&1) return;
	
#define IsPress(a) (((keyval&a)==a)&&!((old_key&a)==a))
#define IsNotPress(a) (!((keyval&a)==a)&&((old_key&a)==a))
#define HandleKey(a,b) {\
	if (IsPress(a)){		\
		event.type = ev_keydown;\
		event.data1 = b;\
		H2_PostEvent(&event);\
	}\
	if (IsNotPress(a)){\
		event.type = ev_keyup;\
		event.data1 = b;\
		H2_PostEvent(&event);\
	}}	
	
	keyval=0;
	key = KeyCurrentState();		
	
	penDown=0;
	/*if (!(pollcpt&3))*/{
		EvtGetPen(&penX,&penY,&penDown);
		
	}
	//handle sys event
#ifndef ENABLE_ZGRAB	
	if (!(pollcpt&31)) {YDK_HANDLE_EVENT()}
#else
	YDK_HANDLE_EVENT()
#endif	
	//avoid autoff
	//every 1024 frame => 
	if (!(pollcpt&1023)) EvtResetAutoOffTimer();
	;					
	
	if (penDown){
		PointType pt;
		pt.x=penX;
		pt.y=penY;
		EvtEnqueuePenPoint(&pt);
	}
	
	penX*=_PEN_ADJUST_FACTORX_;
	penY*=_PEN_ADJUST_FACTORY_;
	if (penDown) {
	 	if ((penY>0)&&(penY<60)&&(penX>display_width-80)&&(penX<display_width)) key=BTN_TR;
	 	else if ((penY>(display_height>>1)-30)&&(penY<(display_height>>1)+30)&&(penX>display_width-80)&&(penX<display_width)) key=BTN_MR;
		else if ((penY>display_height-60)&&(penY<display_height)&&(penX>display_width-80)&&(penX<display_width)) key=BTN_BR;
		else if ((penY>0)&&(penY<60)&&(penX>0)&&(penX<80)) key=BTN_TL;
		else if ((penY>(display_height>>1)-30)&&(penY<(display_height>>1)+30)&&(penX>0)&&(penX<80)) key=BTN_ML;
		else if ((penY>display_height-60)&&(penY<display_height)&&(penX>0)&&(penX<80)) key=BTN_BL;
		else if ((penY>0)&&(penY<60)&&(penX>(display_width>>1)-40)&&(penX<(display_width>>1)+40)) key=BTN_TM;
	 	else if ((penY>display_height-60)&&(penY<display_height)&&(penX>(display_width>>1)-40)&&(penX<(display_width>>1)+40)) key=BTN_BM;
	 	else if ((penY>(display_height>>1)-30)&&(penY<(display_height>>1)+30)&&(penX>(display_width>>1)-40)&&(penX<(display_width>>1)+40)) {
	 		char *c;
	 		int result;
	 		stub_consoleCmd(consoleCmd);
	 		YDK_HANDLE_EVENT_NOFUNC()
	 		c=consoleCmd;
	 		if (strcmp(c,"gamma")==0){
	 			event.type = ev_keydown;
				event.data1 = KEY_F11;
				H2_PostEvent(&event);
				event.type = ev_keyup;
				event.data1 = KEY_F11;
				H2_PostEvent(&event);
	 		}else if ((strcmp(c,"quit")==0)||(strcmp(c,"/q")==0)){
	 			event.type = ev_keydown;
				event.data1 = KEY_F10;
				H2_PostEvent(&event);
				event.type = ev_keyup;
				event.data1 = KEY_F10;
				H2_PostEvent(&event);
				event.type = ev_keydown;
				event.data1 = 'y';
				H2_PostEvent(&event);
				event.type = ev_keyup;
				event.data1 = 'y';
				H2_PostEvent(&event);
	 		}else{
	 		while (*c){
	 			event.type = ev_keydown;
				event.data1 = *c;
				H2_PostEvent(&event);
				event.type = ev_keyup;
				event.data1 = *c++;
				H2_PostEvent(&event);
	 		}
	 		}
	 	}
	}
	
	//if ((key==BTN_TM)||(key==BTN_BM)||(key==BTN_TL)||(key==BTN_TR)||(key==BTN_ML)||(key==BTN_MR)||(key==BTN_BL)||(key==BTN_BR)){
	if (penDown){
	for (int i=0;i<30;i++)
		 if (g_confinput[i]!=0)
				if (key==g_confinput[i]) {keyval=g_translateBtn[i];break;}
	}
	else {
		for (i=0;i<30;i++)
			if (g_confinput[i]!=0)
				if ( (key & g_confinput[i])==g_confinput[i]) keyval|=g_translateBtn[i];	
	}
	HandleKey(KEY_MAP,KEY_TAB)
	HandleKey(KEY_CHANGEWEAPON,'/')
	HandleKey(KEY_FIRE,KEY_ENTER)
	HandleKey(KEY_RUN,KEY_RSHIFT)
	HandleKey(KEY_USE,KEY_RCTRL)
	HandleKey(KEY_STRAFE_L,KEY_HOME)
	HandleKey(KEY_STRAFE_R,KEY_PGUP)
	HandleKey(KEY_STRAFE,KEY_RALT)
	HandleKey(KEY_MENU,KEY_ESCAPE)
	HandleKey(KEY_UP,KEY_UPARROW)
	HandleKey(KEY_DOWN,KEY_DOWNARROW)
	HandleKey(KEY_LEFT,KEY_LEFTARROW)
	HandleKey(KEY_RIGHT,KEY_RIGHTARROW)
	HandleKey(KEY_JUMP,'x')
	HandleKey(KEY_INV_LEFT,'[')
	HandleKey(KEY_INV_RIGHT,']')
	HandleKey(KEY_USEARTIFACT,' ')
	HandleKey(KEY_FLYUP,'w')
	HandleKey(KEY_FLYDOWN,'s')
	HandleKey(KEY_FLYCENTER,'c')
	HandleKey(KEY_LOOKUP,'q')
	HandleKey(KEY_LOOKDOWN,'z')
	HandleKey(KEY_LOOKCENTER,'a')
	HandleKey(KEY_GAMMA,KEY_F11)
	HandleKey(KEY_PLUS,KEY_EQUALS)
	HandleKey(KEY_MOINS,KEY_MINUS)
			
	old_key=keyval;
#undef HandleKey		
#undef IsPress	
#undef IsNotPress	


/* SDL_Event Event;
 while (SDL_PollEvent(&Event)) {

 switch(Event.type) {
  case SDL_KEYUP:
  case SDL_KEYDOWN:
  switch(Event.key.keysym.sym) {
   case SDLK_UP:
   case SDLK_KP8:
   event.data1=KEY_UPARROW; break;

   case SDLK_DOWN:
   case SDLK_KP2:
   event.data1=KEY_DOWNARROW; break;
 
   case SDLK_RIGHT:
   case SDLK_KP6:
   event.data1=KEY_RIGHTARROW; break;

   case SDLK_LEFT:
   case SDLK_KP4:
   event.data1=KEY_LEFTARROW; break;

   case SDLK_HOME:
   case SDLK_KP7:
   event.data1=KEY_HOME; break;
   
   case SDLK_PAGEUP:
   case SDLK_KP9:
   event.data1=KEY_PGUP; break;

   case SDLK_PAGEDOWN:
   case SDLK_KP3:
   event.data1=KEY_PGDN; break;

   case SDLK_END:
   case SDLK_KP1:
   event.data1=KEY_END; break;

   case SDLK_RSHIFT:
   case SDLK_LSHIFT:
   event.data1=KEY_RSHIFT; break;

   case SDLK_RCTRL:
   case SDLK_LCTRL:
   event.data1=KEY_RCTRL; break;

   case SDLK_RALT:
   case SDLK_LALT:
   event.data1=KEY_RALT; break;

   case SDLK_F1:
   event.data1=KEY_F1; break;
   case SDLK_F2:
   event.data1=KEY_F2; break;
   case SDLK_F3:
   event.data1=KEY_F3; break;
   case SDLK_F4:
   event.data1=KEY_F4; break;
   case SDLK_F5:
   event.data1=KEY_F5; break;
   case SDLK_F6:
   event.data1=KEY_F6; break;
   case SDLK_F7:
   event.data1=KEY_F7; break;
   case SDLK_F8:
   event.data1=KEY_F8; break;
   case SDLK_F9:
   event.data1=KEY_F9; break;
   case SDLK_F10:
   event.data1=KEY_F10; break;
   case SDLK_F11:
   event.data1=KEY_F11; break;
   case SDLK_F12:
   event.data1=KEY_F12; break;

   default:
      event.data1=Event.key.keysym.sym;
   
  }
  event.type=Event.type==SDL_KEYDOWN ? ev_keydown : ev_keyup;
  H2_PostEvent(&event);
 break;
 case SDL_MOUSEBUTTONUP:
  if (!usemouse) break;
  event.data1=0;
  switch(Event.button.button) {
   case SDL_BUTTON_LEFT:
    event.data1&=1; break;
   case SDL_BUTTON_RIGHT:
    event.data1&=~4; break;
   case SDL_BUTTON_MIDDLE:
    event.data1&=~2; break;
  }
  save_buttons=event.data1;
  event.data2=0;
  event.data3=0;
  event.type=ev_mouse;
  H2_PostEvent(&event);
 break;
 case SDL_MOUSEBUTTONDOWN:
  if (!usemouse) break;
  event.data1=0;
  switch(Event.button.button) {
   case SDL_BUTTON_LEFT:
    event.data1|=1; break;
   case SDL_BUTTON_RIGHT:
    event.data1|=4; break;
   case SDL_BUTTON_MIDDLE:
    event.data1|=2; break;
  }
  save_buttons=event.data1;
  event.data2=0;
  event.data3=0;
  event.type=ev_mouse;
  H2_PostEvent(&event);
 break;
 case SDL_MOUSEMOTION:
  if (!usemouse) break;
  event.data1=save_buttons;
  if (Event.motion.x==SDLWidth/2 && Event.motion.y==SDLHeight/2) break;
  if ((event.data2=(Event.motion.xrel)*mouse_scale_factor) ||
      (event.data3=(-Event.motion.yrel)*mouse_scale_factor)) {
    SDL_WarpMouse(SDLWidth/2,SDLHeight/2);
    event.type=ev_mouse;
    H2_PostEvent(&event);
  }
  break;
  } 
 }*/
}


void VSDL_FinishUpdate(void) {
    int xx,yy;
	UInt16 *dest;
	UInt8 *src;
	
	dest=(UInt16*)(g_pnobridge->vram);
	src=(UInt8*)(screen);
	if (SCREENWIDTH==480){
		if (g_scr_rotated) zq_asmfastrender480r(dest,src,curpal,/*320*2*/(g_pnobridge->display_pitch)*2,SCREENHEIGHT);
		else zq_asmfastrender480(dest,src,curpal,(g_pnobridge->display_pitch)*2,SCREENHEIGHT);
	if (SCREENWIDTH==320) zq_asmfastrender320(dest,src,curpal,(g_pnobridge->display_pitch)*2,SCREENHEIGHT);
	}else{
		for (yy=SCREENHEIGHT;yy;yy--){
			for (xx=SCREENWIDTH;xx;xx--){
				*dest++=curpal[*src++];
			}
		dest+=(g_pnobridge->display_pitch)-SCREENWIDTH;
		}
	}	
}

void VSDL_SetPalette(byte *palette)
{
    UInt16 c;
	int i;
    for (i=0 ; i<256 ; i++)
	{
		c =  (gammatable[usegamma][*palette++]>>3)<<11;
		c |= (gammatable[usegamma][*palette++]>>2)<<5;
		c |= (gammatable[usegamma][*palette++]>>3);
		curpal[i]=c;
	}
}

#endif
void VSDL_Stub(void)
{

}

int dummy_align5;
byte tmp_screen[320*200];

void I_Extend320200ToScreen(UInt8 *vid){
	byte *pp,*q;
	int xt,yt,xx,yy,xincr,yincr,xofs,yofs;
	
	if ((SCREENWIDTH==320)||!vid) return;

	
	pp=tmp_screen;q=vid;
	for (yy=0;yy<200;yy++){
		memcpy(pp,q,320);
		pp+=320;
		q+=SCREENWIDTH;
	}
	
	q=vid;
	yofs=0;yincr=(200<<16)/SCREENHEIGHT;
	xincr=(320<<16)/SCREENWIDTH;
	for (yy=0;yy<SCREENHEIGHT;yy++){
		xofs=0;
		yt=(yofs>>16); if (yt>199) yt=199;
		pp=&tmp_screen[yt*320];
		for (xx=0;xx<SCREENWIDTH;xx++){
			xt=(xofs>>16); if (xt>319) xt=319;
			q[xx]=pp[xt];			
			xofs+=xincr;
		}
		q+=SCREENWIDTH;		
		yofs+=yincr;
	}

}