/*#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <stdarg.h>
#include <sys/time.h>
#include <unistd.h>
#include <SDL.h>*/

#include "h2def.h"

int	mb_used = 6;

extern char exit_hexen;

void
I_Tactile(int on, int off,  int total)
{
//  on = off = total = 0;
}

ticcmd_t	emptycmd;
ticcmd_t*	I_BaseTiccmd(void)
{
    return &emptycmd;
}

int  I_GetHeapSize (void)
{
    return mb_used*1024*1024;
}

byte* I_ZoneBase (int*	size)
{
   	byte *res;
	int max,bytes;
/*	MemHeapFreeBytes ( 0, &bytes, &max );	
  	Sys_PrintF("ram : %d/%d",bytes>>10,max>>10);
  	menu_info(" ");
  */
  	mb_used = 8;
  	for (;;){
    	res=(byte *) ydk_malloc ((mb_used*1024+1024)*1024);   
    	if (res) break;
    	mb_used-=1;
    }
    free(res);
    Sys_PrintF("Allocated %dMB",mb_used);
//    menu_info(" ");
    if (mb_used<2) {
    	I_Error("Warning low mem");
    }
    
    *size = mb_used*1024*1024;
   	res=(byte *) ydk_malloc (*size);
   	
/*   	
   	MemHeapFreeBytes ( 0, &bytes, &max );	
  	Sys_PrintF("ram : %d/%d",bytes>>10,max>>10);
  	menu_info(" ");
  */ 	
    return res;
}

int  I_GetTime (void)
{
//  return (TICRATE*SDL_GetTicks())/1000;
	static int		basetime=0;
    int newtics=GetTickCount();
    if (!basetime) basetime=newtics;    
    return (newtics-basetime)*TICRATE/1000;
}

void I_Init (void)
{
    S_Init();
}

void I_Quit (void)
{
/*    D_QuitNetGame ();
    I_ShutdownSound();
    M_SaveDefaults ();
    I_ShutdownGraphics();
    exit(0);*/
    exit_hexen=1;
}

void I_WaitVBL(int count)
{
//  SDL_Delay(count * (10000/70));
	int start=GetTickCount();
	int delay=count*(1000/70);
	while ((GetTickCount()-start)<delay) ;
}

void I_BeginRead(void)
{
}

void I_EndRead(void)
{
}

byte*	I_AllocLow(int length)
{
    byte* mem;
    mem=(byte *)malloc(length);
    memset(mem,0,length);
    return mem;
}

extern boolean demorecording;

void I_Error (char *error, ...)
{
    va_list	argptr;
    char text[1024];

    // Message first.
    va_start (argptr,error);
//    fprintf (stderr, "Error: ");
    vsprintf (text,error,argptr);
//    fprintf (stderr, "\n");
    va_end (argptr);

//    fflush( stderr );
	menu_info(text);	


    // Shutdown. Here might be other errors.
/*    if (demorecording)
	G_CheckDemoStatus();

    D_QuitNetGame ();
    I_ShutdownGraphics();
    
    exit(-1);*/
}
